SystemOrganization addCategory: #ConfigurationOfMacros!

Object subclass: #ConfigurationOfMacros
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMacros'!

!ConfigurationOfMacros class methodsFor: 'development support' stamp: 'mig 2/16/2011 16:55'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMacros class methodsFor: 'private' stamp: 'mig 2/16/2011 16:55'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMacros class methodsFor: 'private' stamp: 'mig 2/16/2011 16:55'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMacros class methodsFor: 'private' stamp: 'mig 2/16/2011 16:55'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMacros class methodsFor: 'metacello tool support' stamp: 'mig 2/16/2011 16:55'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMacros class methodsFor: 'loading' stamp: 'mig 2/16/2011 16:55'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMacros class methodsFor: 'accessing' stamp: 'mig 2/16/2011 16:55'!
project

	^self new project! !

!ConfigurationOfMacros class methodsFor: 'development support' stamp: 'mig 2/16/2011 16:55'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMacros methodsFor: 'baselines' stamp: 'mig 2/18/2011 17:56'!
baseline100: spec
	<version: '1.0-baseline'>
	
	spec for: #common do: [
			spec blessing: #baseline.
			spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/macros'.
			
			spec
				package: 'VB-Regex'
				with: [spec repository: 'http://www.squeaksource.com/Regex'].
			
			spec
				package: 'CTM' 
				with: [
						spec requires: #('VB-Regex').
						spec postLoadDoIt: #postLoadListener].
			
			spec group: 'default' with: #('CTM').
		].! !

!ConfigurationOfMacros methodsFor: 'postload' stamp: 'mig 2/18/2011 16:53'!
postLoadListener

	(Smalltalk at: #CTMEventListener) instance register.! !

!ConfigurationOfMacros methodsFor: 'accessing' stamp: 'mig 2/16/2011 16:55'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMacros methodsFor: 'symbolic versions' stamp: 'mig 2/16/2011 17:04'!
stable: spec
    <symbolicVersion: #'stable'>
    spec for: #common version: '1.0'.
! !

!ConfigurationOfMacros methodsFor: 'versions' stamp: 'mig 2/18/2011 17:57'!
version100: spec
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec
			package: 'CTM' with: 'CTM-mig.60';
			package: 'VB-Regex' with: 'VB-Regex-damienpollet.17'.
		].! !
